# HTML traceback formater by A. Artamonov 2002.04.11
# JavaScript part checked with win32 IE6.0 and NN4.5 and X-Win NN4.75
# Use mouse click on any link to prevent source window from closing.
# For those who do not have JS support it's possible to use plain text mode.
# Though it's not so funny as with JS. Turn TextMode='1' to use it in text mode.

TextMode=''  # set ='1' for using non-Javascript mode
skips = ['request','response','REQUEST','RESPONSE'] #variables omited from displaying
lines_2_show = 2 #show 2 lines up and down from error line
show_line_info = '1' #show fule/line# info in layer
max_expr_len = 100 # show only max_expr_len bytes of long variables

import string
js_funct='''
<Script Language="JavaScript">
<!--
var submenu=new Array(%s);
var x=0;
var y=0;
var cur_itm=null;
var fixed= false;
var nailed = false;
function myScroll(e) 
{
    if (document.layers ) 
    {
        x=window.pageXOffset+10;
        y=e.screenY - window.screenY - (window.outerHeight - window.innerHeight) + window.pageYOffset-50;
    }
    else if (document.all) 
    {
       x = document.body.scrollLeft+10;
       y = window.event.y + document.body.scrollTop-50;
    }
}

function prepBrowser() 
{
    if (document.layers) 
    {
        %s
        document.captureEvents(Event.MOUSEMOVE);
        document.onmousemove = myScroll;

    }
    else if (document.all) 
    {
        %s        
        document.onmousemove = myScroll;
    }
}


function HideSrc()
{
    if (nailed) return;
    if (!cur_itm) return;
    cur_itm.visibility = "hidden";
    cur_itm=null;
}

function DisplaySrc(itm)
{
    if (nailed) return;
    if (cur_itm==submenu[itm]) return;
    if (cur_itm) {cur_itm.visibility = "hidden";cur_itm=null;}
    submenu[itm].visibility = "visible";
    submenu[itm].top=y;
    submenu[itm].left=x;
    cur_itm=submenu[itm];
}

function nail(itm)
{
    
    if (nailed && cur_itm==submenu[itm]) 
    {
        cur_itm.visibility = "hidden";
        nailed = false;
    }
    else
    {   
        nailed = false;
        DisplaySrc(itm);
        nailed=true;
    }
    return false;
}

function unnail()
{
    nailed = false;
    HideSrc();
    return false;
}


// -->

</Script>
'''


div_pat = """
    <DIV id=dropdown%s
    style="LEFT: 10px; POSITION: absolute; TOP: 10px; VISIBILITY: hidden;  Z-INDEX: 1;">
      <TABLE bgColor=#F0F0F0 border=1 cellPadding=5 cellSpacing=0><TBODY><th>
      <TABLE bgColor=#F0F0F0 border=0 cellPadding=0 cellSpacing=0>
      <TBODY>
      <TR>
        <TD vAlign=top><IMG border=0 height=1 src="" 
          width=1><BR>
        </TD>
        <TD vAlign=top>
         %s
        </TD>
      </TR>
      </TBODY>
    </TABLE></th></TBODY></TABLE>
    </DIV>
    """

def un_linebr(s):
    try: c = s[-1]
    except: return s
    
    while c == "\n" or c == "\r":
        s = s[:-1]
        try: c = s[-1]
        except: return s
        
    return s

def ident_of(s):
    ret = 0
    if not s : return ret
    idnt = s[0]
    if s[0]=='\t': div=1
    elif s[0]==' ':div=4
    else: return ret
    slen=len(s)
    while s[ret]==idnt: 
        ret+=1
        if ret==slen:break
    ret = ret/div
    return ret

def quoteHTML(text,subs={'&':'&amp;', "<":'&lt;', ">":'&gt;', '\"':'&quot;',' ':'&nbsp;','\n':'<br>'}):
    for ent in '&<>\" \n':
        if string.find(text, ent) >= 0:
            text=string.join(string.split(text,ent),subs[ent])

    return text
         
def format_exception(etype,value,tb,limit=None):
    import traceback
    result=['Traceback (innermost last):']
    if limit is None:
            if hasattr(sys, 'tracebacklimit'):
                    limit = sys.tracebacklimit
    n = 0
    nn_patern = "submenu[%s] = document.dropdown%s;\n"
    ie_patern = "submenu[%s] = dropdown%s.style;\n"
    nn_arr=""
    ie_arr=""
    divs  =""
    name_chars = '_' + string.digits + string.letters
    while tb is not None and (limit is None or n < limit):
            f = tb.tb_frame
            lineno = tb.tb_lineno
            co = f.f_code
            filename = co.co_filename
            name = co.co_name
            locals=f.f_locals
            globals=f.f_globals
            err_line = ''
            if TextMode:
                result.append("  File %s, line %d, in %s" % (quoteHTML(filename),lineno,quoteHTML(name) ) )
            else:
                result.append("  File %s, line %d, in <a href='#show src' onmouseover='DisplaySrc(%s);' ondblclick='return unnail();' onclick='return nail(%s);' onmouseout='HideSrc();'>%s</a>"% (quoteHTML(filename),lineno,n,n,quoteHTML(name)) )

            try: 
                f = open(filename)
                lns=f.readlines()
                f.close()
            except: lns=[]

            
            if show_line_info and not TextMode:
                st = "  File %s, line <font color='red'>%d</font>, in <font color='blue'>%s</font><br> " % (quoteHTML(filename),lineno,quoteHTML(name) )
            else: st=' '

            for l in range (lineno - lines_2_show-1,lineno + lines_2_show):
                try: txt=lns[l]
                except: txt=''
                if not txt: continue
                txt = un_linebr(txt)

                if l <> lineno-1: 
                    st += "<font color='gray'>%s:</font><font color='navy'> %s </font><br>" % ( l+1,quoteHTML(txt) )
                    if l < lineno - 1 : continue
                    if ident_of(txt) <= ident_of(err_line): continue #not miltilined expression
                    if (err_line.strip())[-1] ==':' : continue #not miltilined expression
                else:
                    err_line = txt
                    st += "<font color='red'>%s:</font><font color='purple'> %s </font><br>" % ( l+1,quoteHTML(txt) )

                var_st=""
                var_ident = ".&nbsp;&nbsp;"*5
                txt_len = len(txt) - 1
                
                for k,v  in locals.items()+globals.items():
                    if k in skips: continue
                    name_end = 0
                    while 1:
                        name_start = txt.find(k,name_end)
                        if name_start==-1: break
                        name_end = name_start+len(k)
                        if name_end > txt_len: break

                        if name_start>0 and txt[name_start-1] in name_chars: continue #part of other variable
                        if txt[name_end] in name_chars: continue #part of other variable
                        tmp = v
                        if type(tmp)<>type(''):tmp=`tmp`
                        tmp.replace('\n','<br>')
                        
                        if len(tmp)>max_expr_len: 
                            expr = quoteHTML(tmp[:max_expr_len])+" <font color='pink'>... %s more bytes (not shown)</font>" % (len(tmp)-max_expr_len)
                        else:
                            expr= quoteHTML(tmp)

                        var_st += var_ident+"%s= <font color='teal'>%s</font><br>" % (k ,expr  )
                        break
                if var_st:
                    st += "<font color='green'>%s</font> " % var_st
            st = "<small>"+st+"</small>"

            if TextMode: result.append(st)
            ie_arr += ie_patern % (n,n)
            nn_arr += nn_patern % (n,n)
            
            divs += div_pat % (n,st)


            try: result.append(quoteHTML('    (Object: %s)' %
                               locals[co.co_varnames[0]].__name__))
            except: pass
            try: result.append(quoteHTML('    (Info: %s)' %
                               str(locals['__traceback_info__'])))
            except: pass
            tb = tb.tb_next
            n = n+1

    result.append(quoteHTML(string.join(traceback.format_exception_only(etype, value),
                       ' ')))
    if TextMode: return '',string.join(result,'\n'),''

    hdr = js_funct % (n,nn_arr,ie_arr) + divs
    ftr = '<Script Language="JavaScript"><!--\nprepBrowser();\n// --></Script>'
    
    return hdr,string.join(result,'\n'),ftr

def new_tb(t,v,tb,debug_mode):
    hdr,tb,ftr = format_exception(t,v,tb,200)
    
    if debug_mode: _tbopen, _tbclose = '<PRE>', '</PRE>'
    else: 
        _tbopen, _tbclose = '''<pre
            onclick="this.firstChild.data=this.lastChild.data">
        &sect;<!--''',  '--></pre>'
    return "\n%s\n%s\n%s\n%s\n%s" % (hdr,_tbopen, tb, _tbclose,ftr)